using System;
using System.ComponentModel;
using System.Collections;
using System.Diagnostics;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Windows.Forms;
using System.Data;


namespace CustomControl
{
	/// <summary>
	/// Summary description for VirtualGrid.
	/// </summary>
	public class VirtualGrid : GridControl
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public VirtualGrid(System.ComponentModel.IContainer container)
		{
			///
			/// Required for Windows.Forms Class Composition Designer support
			///
			container.Add(this);
			InitializeComponent();

			CellModels.Add("DropDownFilter", new DropDownFormCellModel(Model));

			// Custom Control Filters..
			this[2,5].CellType = "DropDownFilter";
			this[1,5].Text = "Custome Control"; 
			this[2,5].ExclusiveChoiceList = true;
			this[2,5].DropDownStyle = GridDropDownStyle.Exclusive;						
			this[2,5].DataSource = PopulateData();
			this[2,5].ValueMember = "Name";

			// Standard Combo Filters..
			this[5,5].CellType = "ComboBox";
			this[4,5].Text = "Standard Combo"; 
			this[5,5].ExclusiveChoiceList = true;
			this[5,5].DropDownStyle = GridDropDownStyle.Exclusive;			
			this[5,5].DataSource = PopulateData();
			this[5,5].ValueMember = "Name";
		}

		private DataTable PopulateData()		
		{
			DataTable dt = new DataTable("Employee");
			DataRow dr;
			dt.Columns.Add(new DataColumn("Name", typeof(String)));

			for (int i=0; i<=5; i++) 
			{
				dr = dt.NewRow(); 
				dr[0] = "Sathish" + i; 
				dt.Rows.Add(dr);         
			}

			return dt;		
		}

		public VirtualGrid()
		{
			
			///
			/// Required for Windows.Forms Class Composition Designer support
			///
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion
	}
}
